#!/usr/bin/python

# Dock script (Return Shuttles Addon) by Defiant <mail@defiant.homedns.org>


# Imports
import App
import MissionLib
import Bridge.BridgeUtils
import Lib.Ambiguity
import QuickBattle.QuickBattle

# Vars
pBridge = App.g_kSetManager.GetSet('bridge')
BridgeType = App.BridgeSet_Cast(pBridge).GetConfig()
g_pKiska = App.CharacterClass_GetObject(pBridge, 'Helm')
pKiskaMenu = Bridge.BridgeUtils.GetBridgeMenu('Helm')
SHUTTLES_DOCK = App.Mission_GetNextEventType()
g_pGeblePodTargets = None

def ShuttlesDock(pObject, pEvent):
	print("Docking...")
		
	pGame = App.Game_GetCurrentGame()
	pEpisode = pGame.GetCurrentEpisode()
	pMission = pEpisode.GetCurrentMission()
	pFriendlies = pMission.GetFriendlyGroup()
	pPlayer = MissionLib.GetPlayer()

	if not pPlayer.GetTarget():
		print("No Target - No Docking")
		return
	
	if (pFriendlies.IsNameInGroup(pPlayer.GetTarget().GetName()) != 1):
		print("Target is Enemy")
		return
	else:
		print("Target is Friendly...Going on")
	
	
	pTarget = MissionLib.GetShip(pPlayer.GetTarget().GetName())
	g_pGeblePodTargets = App.ObjectGroup()
	g_pGeblePodTargets.AddName(pPlayer.GetName())
	
	Getg_pGeblePodTargets()
	
	if not pTarget:
		print("Error in Target")
		return
	
	AIModule = __import__("AI.Compound.TractorTarget")
	pTarget.SetAI(AIModule.CreateAI(pTarget, App.ObjectGroup_FromModule("Custom.QBautostart.Dock", "g_pGeblePodTargets")))

def Getg_pGeblePodTargets():
	global g_pGeblePodTargets
	pPlayer = MissionLib.GetPlayer()
	
	g_pGeblePodTargets = None
	g_pGeblePodTargets = App.ObjectGroup()
	g_pGeblePodTargets.AddName(pPlayer.GetName())


if (pKiskaMenu != None):
	event = Lib.Ambiguity.getEvent(SHUTTLES_DOCK)
	g_pKiska.AddPythonFuncHandlerForInstance(event, __name__ + ".ShuttlesDock")
	pButton = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString("Dock at Target"), event, 0, g_pKiska)
	pKiskaMenu.PrependChild(pButton)
